import * as suggy from "../../index.js";

class ItemUse {
    constructor(src) {
    this.nameTag = src.nameTag;
    this.name = src.name;
    this.dimension = src.dimension;
    this.id = src.id;
    this.isSneaking = src.isSneaking;
    this.location = src.location;
    this.me = src;
    }
    
    addTag(tag) {
   return this.me.addTag(tag)    
    }
    
    removeTag(tag) {
   return this.me.removeTag(tag)    
    }
    
    getTags() {
   return this.me.getTags() 
    }
    
    getEffect() {
    return this.me.getEffect()    
    }
    
    getComponent(component) {
    return this.me.getComponent(component)    
    }
    
    getComponents() {
     return this.me.getComponents()   
    }
    
    reply(message) {
    return suggy.client.runCommand(
      `tellraw "${this.nameTag}" {"rawtext":[{"translate":"${message}"}]}`
    );   
   }
   
   runCommand(cmd) {
   try {
  return suggy.world.getDimension("overworld").runCommand(`execute "${this.nameTag}" ~~~ ${cmd}`)
    } catch (error) {
     throw new Error(error)
    }
   }
   
   error(message) {
    return suggy.client.runCommand(
      `tellraw "${this.nameTag}" {"rawtext":[{"translate":"§l§cERROR: §r§c${message}"}]}`
    );   
  }
    
  actionbar(text) {
    return suggy.client.runCommand(
    `titleraw "${this.nameTag}" actionbar {"rawtext":[{"translate":"${text}"}]}`    
        )  
  }   
    
}

class Message {
    constructor(data) {
    this.sender = data.sender;
    this.content = data.message;
    this.data = data;
    }
  
  cancel(boo=false) {
    if(boo) return this.data.cancel = true;  
    }
  
   reply(message) {
    return suggy.client.runCommand(
      `tellraw "${this.sender.nameTag}" {"rawtext":[{"translate":"${message}"}]}`
    );   
   }
   
   runCommand(cmd) {
   try {
  return suggy.world.getDimension("overworld").runCommand(`execute "${this.sender.nameTag}" ~~~ ${cmd}`)
    } catch (error) {
     throw new Error(error)
    }
   }
   
   error(message) {
    return suggy.client.runCommand(
      `tellraw "${this.sender.nameTag}" {"rawtext":[{"translate":"§l§cERROR: §r§c${message}"}]}`
    );   
  }
  
  actionbar(text) {
    return suggy.client.runCommand(
    `titleraw "${this.sender.nameTag}" actionbar {"rawtext":[{"translate":"${text}"}]}`    
        )  
  }   
}

export {
    ItemUse,
    Message
}