import { ActionFormData, MessageFormData, ModalFormData } from "mojang-minecraft-ui";

class ActionForm {
    constructor() {
    this.form = new ActionFormData()
     }
    
    setTitle(txt) {
     this.form.title(txt); 
     return this;
    }
    
    setBody(txt) {
      this.form.body(txt);  
      return this;
    }
    
    addButton(text, icon) {
     this.form.button(text, icon ?? undefined)  
     return this;
    }
    
    show(player) {
    return new Promise((resolve, reject) => {
    this.form.show(player).then((res) => {
    resolve(res)  
        }).catch((err) => {
     reject(err)      
        })
        
      })
    }
    
}

class MessageForm {
    constructor() {
    this.form = new MessageFormData()
     }
    
    setTitle(txt) {
     this.form.title(txt); 
     return this;
    }
    
    setBody(txt) {
      this.form.body(txt);  
      return this;
    }
    
    button1(text) {
     this.form.button1(text)  
     return this;
    }
    
    button2(text) {
     this.form.button2(text)  
     return this;
    }
    
    
    show(player) {
      return new Promise((resolve, reject) => {
    this.form.show(player).then((res) => {
    resolve(res)  
    }).catch((err) => {
        reject(err.stack)
    })
    })
    }
    
}

class ModalForm {
    constructor() {
    this.form = new ModalFormData()
     }
    
    addDropdown(label, options=[], defaultValueIndex) {
    this.form.dropdown(label, options, defaultValueIndex ?? 0)  
    return this;
    }
    
    addInput(label, placeholderText, defaultValue) {
     this.form.textField(label, placeholderText, defaultValue ?? "")   
     return this;
    }
    
    addSlider(label, minimumValue, maximumValue, valueStep, defaultValue) {
    this.form.slider(label, minimumValue, maximumValue, valueStep, defaultValue ?? 0)   
    return this;
    }
    
    addToggle(label, defaultValue) {
     this.form.toggle(label, defaultValue ?? false)
     return this;
    }
    
    setTitle(txt) {
     this.form.title(txt); 
     return this;
    }
    
    show(player) {
      return new Promise((resolve, reject) => {
    this.form.show(player).then((res) => {
    resolve(res)  
    }).catch((err) => {
    reject(err.stack)  
    })
    })
    }
}

export { 
    ActionForm,
    MessageForm,
    ModalForm
};